#include<iostream>
#include<unistd.h>
#include<stdlib.h>
#include<time.h>

#include "rpwRand.h"

using namespace std;

int main(int argc, char *argv[])
{
  int maxSize;
  int number;

  // --- Command line error catching ----
  if (argc < 3)
  {
    cerr << "Incorrect usage.  You must specify two command line parameters:" << endl
         << "  - The max range of the elements in the data set" << endl
         << " -  The number of data elements you wish to draw" << endl << endl
	 <<  "  " << argv[0] << " <maxsize> <number>" <<endl << endl;
    return(1);
  }

  try
  {
    maxSize = atoi(argv[1]);
    number  = atoi(argv[2]);
  }
  catch(...)
  {
    cerr << "Incorrect usage.  At least one of your arguments was not an integer.  " << endl
	  << "You must specify two command line parameters:" << endl
          << "  - The max range of the elements in the data set" << endl
         << " -  The number of data elements you wish to draw" << endl << endl
	 <<  "  " << argv[0] << " <maxsize> <number>" <<endl << endl;
    return(1);
  }

  if (number > maxSize)
  {
    cerr << "Incorrect usage.  The number of data elements you select cannot exceed the data range of the set" << endl
	  << "You must specify two command line parameters:" << endl
          << "  - The max range of the elements in the data set" << endl
         << " -  The number of data elements you wish to draw" << endl << endl
	 <<  "  " << argv[0] << " <maxsize> <number>" <<endl << endl;
    return(1);
  }
  // --- Command line error catching ----



  // Initialize the random seed to the pid * current system time
  initRand( getpid() * (unsigned int)time(NULL) );

  int *A = new int[maxSize];
  permRand(A,maxSize);

  for (int i=0; i<number; i++)
    cout << A[i] << endl;

  return(0);
}
